Index: issm/trunk/src/c/objects/Tria.cpp
===================================================================
--- issm/trunk/src/c/objects/Tria.cpp	(revision 464)
+++ issm/trunk/src/c/objects/Tria.cpp	(revision 465)
@@ -266,20 +266,24 @@
 #define __FUNCT__ "Tria::CreateKMatrix"
 
-void  Tria::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type){
+void  Tria::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	/*Just branch to the correct element stiffness matrix generator, according to the type of analysis we are carrying out: */
-	if ((analysis_type==DiagnosticHorizAnalysisEnum()) || (analysis_type==ControlAnalysisEnum())){
-
-		CreateKMatrixDiagnosticHoriz( Kgg,inputs,analysis_type);
-
-	}
-	else if (
-			(analysis_type==SurfaceSlopeComputeXAnalysisEnum()) || 
-			(analysis_type==SurfaceSlopeComputeYAnalysisEnum()) || 
-			(analysis_type==BedSlopeComputeXAnalysisEnum()) || 
-			(analysis_type==BedSlopeComputeYAnalysisEnum()) 
-			){
-		
-		CreateKMatrixSlopeCompute( Kgg,inputs,analysis_type);
+	if (analysis_type==ControlAnalysisEnum()){
+		
+		CreateKMatrixDiagnosticHoriz( Kgg,inputs,analysis_type,sub_analysis_type);
+	}
+	else if (analysis_type==DiagnosticAnalysisEnum()){
+	
+		if (sub_analysis_type==HorizAnalysisEnum()){
+
+			CreateKMatrixDiagnosticHoriz( Kgg,inputs,analysis_type,sub_analysis_type);
+		}
+		else throw ErrorException(__FUNCT__,exprintf("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet"));
+
+	}
+	else if (analysis_type==SlopeComputeAnalysisEnum()){
+
+		CreateKMatrixSlopeCompute( Kgg,inputs,analysis_type,sub_analysis_type);
+
 	}
 	else{
@@ -293,5 +297,5 @@
 #define __FUNCT__ "Tria::CreateKMatrixDiagnosticHoriz"
 
-void  Tria::CreateKMatrixDiagnosticHoriz(Mat Kgg,void* vinputs,int analysis_type){
+void  Tria::CreateKMatrixDiagnosticHoriz(Mat Kgg,void* vinputs,int analysis_type,int sub_analysis_type){
 
 
@@ -477,5 +481,5 @@
 	/*Do not forget to include friction: */
 	if(!shelf){
-		CreateKMatrixDiagnosticHorizFriction(Kgg,inputs,analysis_type);
+		CreateKMatrixDiagnosticHorizFriction(Kgg,inputs,analysis_type,sub_analysis_type);
 	}
 
@@ -508,5 +512,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::CreateKMatrixDiagnosticHorizFriction"
-void  Tria::CreateKMatrixDiagnosticHorizFriction(Mat Kgg,void* vinputs,int analysis_type){
+void  Tria::CreateKMatrixDiagnosticHorizFriction(Mat Kgg,void* vinputs,int analysis_type,int sub_analysis_type){
 
 
@@ -677,5 +681,5 @@
 #define __FUNCT__ "Tria::CreateKMatrixSlopeCompute"
 
-void  Tria::CreateKMatrixSlopeCompute(Mat Kgg,void* vinputs,int analysis_type){
+void  Tria::CreateKMatrixSlopeCompute(Mat Kgg,void* vinputs,int analysis_type,int sub_analysis_type){
 
 	/* local declarations */
@@ -758,18 +762,23 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::CreatePVector"
-void  Tria::CreatePVector(Vec pg,void* inputs,int analysis_type){
+void  Tria::CreatePVector(Vec pg,void* inputs,int analysis_type,int sub_analysis_type){
 	
 	/*Just branch to the correct load generator, according to the type of analysis we are carrying out: */
-	if ((analysis_type==DiagnosticHorizAnalysisEnum()) || (analysis_type==ControlAnalysisEnum())){
-		CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type);
-	}
-	else if (
-			(analysis_type==SurfaceSlopeComputeXAnalysisEnum()) || 
-			(analysis_type==SurfaceSlopeComputeYAnalysisEnum()) || 
-			(analysis_type==BedSlopeComputeXAnalysisEnum()) || 
-			(analysis_type==BedSlopeComputeYAnalysisEnum()) 
-			){
-		
-		CreatePVectorSlopeCompute( pg,inputs,analysis_type);
+	if (analysis_type==ControlAnalysisEnum()){
+		
+		CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type,sub_analysis_type);
+	
+	}
+	else if (analysis_type==DiagnosticAnalysisEnum()){
+		if (sub_analysis_type==HorizAnalysisEnum()){
+		
+			CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type,sub_analysis_type);
+		
+		}
+		else throw ErrorException(__FUNCT__,exprintf("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet"));
+	}
+	else if (analysis_type==SlopeComputeAnalysisEnum()){
+		
+		CreatePVectorSlopeCompute( pg,inputs,analysis_type,sub_analysis_type);
 	}
 	else{
@@ -779,10 +788,8 @@
 }
 
-
-
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::CreatePVectorDiagnosticHoriz"
 
-void Tria::CreatePVectorDiagnosticHoriz( Vec pg, void* vinputs, int analysis_type){
+void Tria::CreatePVectorDiagnosticHoriz( Vec pg, void* vinputs, int analysis_type,int sub_analysis_type){
 
 	int             i,j;
@@ -952,5 +959,5 @@
 #define __FUNCT__ "Tria::CreatePVectorSlopeCompute"
 
-void Tria::CreatePVectorSlopeCompute( Vec pg, void* vinputs, int analysis_type){
+void Tria::CreatePVectorSlopeCompute( Vec pg, void* vinputs, int analysis_type,int sub_analysis_type){
 
 	int             i,j;
@@ -992,8 +999,8 @@
 	for(i=0;i<numdofs;i++) pe_g[i]=0.0;
 
-	if ( (analysis_type==SurfaceSlopeComputeXAnalysisEnum()) || (analysis_type==SurfaceSlopeComputeYAnalysisEnum())){
+	if ( (sub_analysis_type==SurfaceXAnalysisEnum()) || (sub_analysis_type==SurfaceYAnalysisEnum())){
 		for(i=0;i<numdofs;i++) param[i]=s[i];
 	}
-	if ( (analysis_type==BedSlopeComputeXAnalysisEnum()) || (analysis_type==BedSlopeComputeYAnalysisEnum())){
+	if ( (sub_analysis_type==BedXAnalysisEnum()) || (sub_analysis_type==BedYAnalysisEnum())){
 		for(i=0;i<numdofs;i++) param[i]=b[i];
 	}
@@ -1020,8 +1027,8 @@
 
 		/*Build pe_g_gaussian vector: */
-		if ( (analysis_type==SurfaceSlopeComputeXAnalysisEnum()) || (analysis_type==BedSlopeComputeXAnalysisEnum())){
+		if ( (sub_analysis_type==SurfaceXAnalysisEnum()) || (sub_analysis_type==BedXAnalysisEnum())){
 			for(i=0;i<numdofs;i++) pe_g_gaussian[i]=Jdet*gauss_weight*slope[0]*l1l2l3[i];
 		}
-		if ( (analysis_type==SurfaceSlopeComputeYAnalysisEnum()) || (analysis_type==BedSlopeComputeYAnalysisEnum())){
+		if ( (sub_analysis_type==SurfaceYAnalysisEnum()) || (sub_analysis_type==BedYAnalysisEnum())){
 			for(i=0;i<numdofs;i++) pe_g_gaussian[i]=Jdet*gauss_weight*slope[1]*l1l2l3[i];
 		}
@@ -1543,5 +1550,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::Du"
-void Tria::Du(Vec du_g,double* velocity,double* obs_velocity,void* vinputs,int analysis_type){
+void Tria::Du(Vec du_g,double* velocity,double* obs_velocity,void* vinputs,int analysis_type,int sub_analysis_type){
 
 	int i;
@@ -1745,11 +1752,11 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::Gradj"
-void  Tria::Gradj(Vec grad_g,double* velocity,double* adjoint,void* inputs,int analysis_type,char* control_type){
+void  Tria::Gradj(Vec grad_g,double* velocity,double* adjoint,void* inputs,int analysis_type,int sub_analysis_type,char* control_type){
 
 	if (strcmp(control_type,"drag")==0){
-		GradjDrag( grad_g,velocity,adjoint,inputs,analysis_type);
+		GradjDrag( grad_g,velocity,adjoint,inputs,analysis_type,sub_analysis_type);
 	}
 	else if (strcmp(control_type,"B")==0){
-		GradjB( grad_g, velocity, adjoint, inputs,analysis_type);
+		GradjB( grad_g, velocity, adjoint, inputs,analysis_type,sub_analysis_type);
 	}
 	else throw ErrorException(__FUNCT__,exprintf("%s%s","control type not supported yet: ",control_type));
@@ -1758,5 +1765,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::GradjDrag"
-void  Tria::GradjDrag(Vec grad_g,double* velocity,double* adjoint,void* vinputs,int analysis_type){
+void  Tria::GradjDrag(Vec grad_g,double* velocity,double* adjoint,void* vinputs,int analysis_type,int sub_analysis_type){
 
 
@@ -1952,5 +1959,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::GradjB"
-void  Tria::GradjB(Vec grad_g,double* velocity,double* adjoint,void* vinputs,int analysis_type){
+void  Tria::GradjB(Vec grad_g,double* velocity,double* adjoint,void* vinputs,int analysis_type,int sub_analysis_type){
 
 	int i;
@@ -2093,5 +2100,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::Misfit"
-double Tria::Misfit(double* velocity,double* obs_velocity,void* vinputs,int analysis_type){
+double Tria::Misfit(double* velocity,double* obs_velocity,void* vinputs,int analysis_type,int sub_analysis_type){
 
 	int i;
@@ -2277,5 +2284,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::CreateKMatrixDiagnosticSurfaceVert"
-void  Tria::CreateKMatrixDiagnosticSurfaceVert(Mat Kgg,void* vinputs,int analysis_type){
+void  Tria::CreateKMatrixDiagnosticSurfaceVert(Mat Kgg,void* vinputs,int analysis_type,int sub_analysis_type){
 
 	int i,j;
@@ -2405,5 +2412,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Tria::CreatePVectorDiagnosticBaseVert"
-void  Tria::CreatePVectorDiagnosticBaseVert(Vec pg,void* vinputs,int analysis_type){
+void  Tria::CreatePVectorDiagnosticBaseVert(Vec pg,void* vinputs,int analysis_type,int sub_analysis_type){
 
 	int             i,j;
Index: issm/trunk/src/c/objects/Tria.h
===================================================================
--- issm/trunk/src/c/objects/Tria.h	(revision 464)
+++ issm/trunk/src/c/objects/Tria.h	(revision 465)
@@ -65,13 +65,13 @@
 		int   MyRank();
 		void  Configure(void* loads,void* nodes,void* materials);
-		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type);
-		void  CreatePVector(Vec pg, void* inputs, int analysis_type);
+		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type);
 		void  UpdateFromInputs(void* inputs);
 		void  GetDofList(int* doflist,int* pnumberofdofs);
 		void  GetDofList1(int* doflist);
-		void  CreateKMatrixDiagnosticHoriz(Mat Kgg,void* inputs,int analysis_type);
-		void  CreateKMatrixDiagnosticHorizFriction(Mat Kgg,void* inputs,int analysis_type);
-		void  CreateKMatrixDiagnosticSurfaceVert(Mat Kgg,void* inputs,int analysis_type);
-		void  CreateKMatrixSlopeCompute(Mat Kgg,void* vinputs,int analysis_type);
+		void  CreateKMatrixDiagnosticHoriz(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreateKMatrixDiagnosticHorizFriction(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreateKMatrixDiagnosticSurfaceVert(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreateKMatrixSlopeCompute(Mat Kgg,void* vinputs,int analysis_type,int sub_analysis_type);
 		void  GetParameterValue(double* pp, double* plist, double* gauss_l1l2l3);
 		void  GetParameterDerivativeValue(double* p, double* plist,double* xyz_list, double* gauss_l1l2l3);
@@ -87,13 +87,13 @@
 		void  GetJacobianInvert(double*  Jinv, double* xyz_list,double* gauss_l1l2l3);
 		void  GetJacobian(double* J, double* xyz_list,double* gauss_l1l2l3);
-		void  Du(Vec du_g,double* u_g,double* u_g_obs,void* inputs,int analysis_type);
-		void  Gradj(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,char* control_type);
-		void  GradjDrag(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type);
-		void  GradjB(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type);
-        double Misfit(double* u_g,double* u_g_obs,void* inputs,int analysis_type);
+		void  Du(Vec du_g,double* u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type);
+		void  Gradj(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type,char* control_type);
+		void  GradjDrag(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type);
+		void  GradjB(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type);
+        double Misfit(double* u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type);
 
-		void  CreatePVectorDiagnosticHoriz(Vec pg,void* inputs,int analysis_type);
-		void  CreatePVectorDiagnosticBaseVert(Vec pg,void* inputs,int analysis_type);
-		void  CreatePVectorSlopeCompute( Vec pg, void* vinputs, int analysis_type);
+		void  CreatePVectorDiagnosticHoriz(Vec pg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreatePVectorDiagnosticBaseVert(Vec pg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreatePVectorSlopeCompute( Vec pg, void* vinputs, int analysis_type,int sub_analysis_type);
 		void* GetMatPar();
 		int   GetShelf();
Index: issm/trunk/src/c/objects/cielo/PenpairLoad.c
===================================================================
--- issm/trunk/src/c/objects/cielo/PenpairLoad.c	(revision 464)
+++ issm/trunk/src/c/objects/cielo/PenpairLoad.c	(revision 465)
@@ -689,5 +689,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "PenpairLoadPenaltyCreateKMatrix"
-int PenpairLoadPenaltyCreateKMatrix( ElemMatrix* *pKe_gg, void* vpthis, ParameterInputs* inputs, int K_flag, double kmax, int analysis_type){
+int PenpairLoadPenaltyCreateKMatrix( ElemMatrix* *pKe_gg, void* vpthis, ParameterInputs* inputs, int K_flag, double kmax, int analysis_type,int sub_analysis_type){
 
 	
@@ -702,8 +702,8 @@
 
 	if (this->penpair.numdofs==1){
-		PenpairLoadPenaltyCreateKMatrixOneDof( pKe_gg,vpthis,inputs,K_flag,kmax,analysis_type);
+		PenpairLoadPenaltyCreateKMatrixOneDof( pKe_gg,vpthis,inputs,K_flag,kmax,analysis_type,sub_analysis_type);
 	}
 	else if (this->penpair.numdofs==2){
-		PenpairLoadPenaltyCreateKMatrixTwoDof( pKe_gg,vpthis,inputs,K_flag,kmax,analysis_type);
+		PenpairLoadPenaltyCreateKMatrixTwoDof( pKe_gg,vpthis,inputs,K_flag,kmax,analysis_type,sub_analysis_type);
 	}
 	else{
@@ -719,5 +719,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "PenpairLoadPenaltyCreateKMatrixOneDof"
-int PenpairLoadPenaltyCreateKMatrixOneDof( ElemMatrix* *pKe_gg, void* vpthis, ParameterInputs* inptus, int K_flag, double kmax, int analysis_type){
+int PenpairLoadPenaltyCreateKMatrixOneDof( ElemMatrix* *pKe_gg, void* vpthis, ParameterInputs* inptus, int K_flag, double kmax, int analysis_type,int sub_analysis_type){
 
 
@@ -769,5 +769,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "PenpairLoadPenaltyCreateKMatrixTwoDof"
-int PenpairLoadPenaltyCreateKMatrixTwoDof( ElemMatrix* *pKe_gg, void* vpthis, ParameterInputs* inputs, int K_flag, double kmax, int analysis_type){
+int PenpairLoadPenaltyCreateKMatrixTwoDof( ElemMatrix* *pKe_gg, void* vpthis, ParameterInputs* inputs, int K_flag, double kmax, int analysis_type,int sub_analysis_type){
 
 
@@ -916,5 +916,5 @@
 #define __FUNCT__ "PenpairLoadPenaltyCreatePVector"
 
-int PenpairLoadPenaltyCreatePVector( ElemVector* *ppe_g, void* vpthis, ParameterInputs* inputs, double kmax, int analysis_type){
+int PenpairLoadPenaltyCreatePVector( ElemVector* *ppe_g, void* vpthis, ParameterInputs* inputs, double kmax, int analysis_type,int sub_analysis_type){
 
 	PenpairLoad* this   = NULL;
@@ -931,5 +931,5 @@
 	}
 	else if (this->penpair.numdofs==2){
-		PenpairLoadPenaltyCreatePVectorTwoDof( ppe_g,vpthis,inputs,kmax,analysis_type);
+		PenpairLoadPenaltyCreatePVectorTwoDof( ppe_g,vpthis,inputs,kmax,analysis_type,sub_analysis_type);
 	}
 	else{
@@ -947,5 +947,5 @@
 #define __FUNCT__ "PenpairLoadPenaltyCreatePVectorTwoDof"
 
-int PenpairLoadPenaltyCreatePVectorTwoDof( ElemVector* *ppe_g, void* vpthis, ParameterInputs* inputs, double kmax, int analysis_type){
+int PenpairLoadPenaltyCreatePVectorTwoDof( ElemVector* *ppe_g, void* vpthis, ParameterInputs* inputs, double kmax, int analysis_type,int sub_analysis_type){
 
 	int             i,j;
@@ -1092,5 +1092,4 @@
 	return noerr;
 }
-int PotentialUnstableConstraints(DataSet* lst,ParameterInputs* inputs,int analysis_type_enum);
 
 /*--------------------------------------------------
@@ -1100,5 +1099,6 @@
 #define __FUNCT__ "PenpairLoadPotentialUnstableConstraint"
 
-int PenpairLoadPotentialUnstableConstraint(int* punstable, void* vpthis,ParameterInputs* inputs, int analysis_type){
+int PotentialUnstableConstraints(DataSet* lst,ParameterInputs* inputs,int analysis_type,int sub_analysis_type);
+int PenpairLoadPotentialUnstableConstraint(int* punstable, void* vpthis,ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 
 	/* vpthis for polymorphic function compatibility */
@@ -1186,5 +1186,5 @@
 #define __FUNCT__ "PenpairLoadPenaltyPreConstrain"
 
-int PenpairLoadPenaltyPreConstrain(int* punstable, void* vpthis,ParameterInputs* inputs, int analysis_type){
+int PenpairLoadPenaltyPreConstrain(int* punstable, void* vpthis,ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 
 	/* vpthis for polymorphic function compatibility */
@@ -1290,5 +1290,5 @@
 #define __FUNCT__ "PenpairLoadPenaltyConstrain"
 
-int PenpairLoadPenaltyConstrain(int* punstable, void* vpthis,ParameterInputs* inputs, int analysis_type){
+int PenpairLoadPenaltyConstrain(int* punstable, void* vpthis,ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 
 	/* vpthis for polymorphic function compatibility */
@@ -1417,5 +1417,5 @@
 #define __FUNCT__ "PenpairLoadPenetration"
 
-int PenpairLoadPenetration(double* ppenetration, void* vpthis,ParameterInputs* inputs, int analysis_type){
+int PenpairLoadPenetration(double* ppenetration, void* vpthis,ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 
 	/* vpthis for polymorphic function compatibility */
Index: issm/trunk/src/c/objects/cielo/PentaElement.c
===================================================================
--- issm/trunk/src/c/objects/cielo/PentaElement.c	(revision 464)
+++ issm/trunk/src/c/objects/cielo/PentaElement.c	(revision 465)
@@ -818,5 +818,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "PentaElementCreateKMatrix"
-int PentaElementCreateKMatrix( ElemMatrix* *pKe_gg, ElemMatrix** pKTe_gg, void* vpthis, ParameterInputs* inputs, int K_flag, int KT_flag, int analysis_type){
+int PentaElementCreateKMatrix( ElemMatrix* *pKe_gg, ElemMatrix** pKTe_gg, void* vpthis, ParameterInputs* inputs, int K_flag, int KT_flag, int analysis_type,int sub_analysis_type){
 
 
@@ -2564,5 +2564,5 @@
 #define __FUNCT__ "PentaElementCreatePVector"
 
-int PentaElementCreatePVector( ElemVector* *ppe_g, void* vpthis, ParameterInputs* inputs, int analysis_type){
+int PentaElementCreatePVector( ElemVector* *ppe_g, void* vpthis, ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 
 	int noerr=1;
@@ -5002,5 +5002,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "PentaElementCreateDuVector"
-int PentaElementCreateDuVector( ElemVector* *pdue_g, void* vpthis, double* velocity, double* obs_velocity, ParameterInputs* inputs, int analysis_type){
+int PentaElementCreateDuVector( ElemVector* *pdue_g, void* vpthis, double* velocity, double* obs_velocity, ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 
 	int noerr=1;
@@ -5077,5 +5077,5 @@
 
 		/*Ok, now triaelement is correctly configured, call on its method CreateDuVector: */
-		noerr=TriaElementCreateDuVector( pdue_g, (void*)triaelement, velocity, obs_velocity, inputs, analysis_type);
+		noerr=TriaElementCreateDuVector( pdue_g, (void*)triaelement, velocity, obs_velocity, inputs, analysis_type,sub_analysis_type);
 
 		/*Now delete tria and triaelement: */
@@ -5092,13 +5092,13 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "PentaElementCreateGradVectors"
-int PentaElementCreateGradjVectors( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type,char* control_type){
+int PentaElementCreateGradjVectors( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type,int sub_analysis_type,char* control_type){
 
 	int noerr=1;
 	
 	if strcasecmp_eq(control_type,"drag"){
-		noerr=PentaElementCreateGradjVectorsDrag( pgradje_g, vpthis, velocity, adjoint, inputs,analysis_type);
+		noerr=PentaElementCreateGradjVectorsDrag( pgradje_g, vpthis, velocity, adjoint, inputs,analysis_type,sub_analysis_type);
 	}
 	else if strcasecmp_eq(control_type,"B"){
-		noerr=PentaElementCreateGradjVectorsB( pgradje_g, vpthis, velocity, adjoint, inputs,analysis_type);
+		noerr=PentaElementCreateGradjVectorsB( pgradje_g, vpthis, velocity, adjoint, inputs,analysis_type,sub_analysis_type);
 	}
 	else{
@@ -5114,5 +5114,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "PentaElementMisfit"
-int PentaElementMisfit( double* pJelem,void* vpthis, double* velocity, double* obs_velocity, ParameterInputs* inputs, int analysis_type){
+int PentaElementMisfit( double* pJelem,void* vpthis, double* velocity, double* obs_velocity, ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 
 	int noerr=1;
@@ -5189,5 +5189,5 @@
 
 		/*Ok, now triaelement is correctly configured, call on its method Misfit: */
-		noerr=TriaElementMisfit(pJelem,(void*)triaelement, velocity, obs_velocity, inputs, analysis_type);
+		noerr=TriaElementMisfit(pJelem,(void*)triaelement, velocity, obs_velocity, inputs, analysis_type,sub_analysis_type);
 
 		/*Now delete tria and triaelement: */
@@ -5204,5 +5204,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "PentaElementCreateGradVectorsDrag"
-int PentaElementCreateGradjVectorsDrag( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type){
+int PentaElementCreateGradjVectorsDrag( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 
 	int noerr=1;
@@ -5279,5 +5279,5 @@
 
 		/*Ok, now triaelement is correctly configured, call on its method CreateGradjVectorsdrag: */
-		noerr=TriaElementCreateGradjVectorsDrag( pgradje_g, (void*)triaelement,velocity, adjoint, inputs,analysis_type);
+		noerr=TriaElementCreateGradjVectorsDrag( pgradje_g, (void*)triaelement,velocity, adjoint, inputs,analysis_type,sub_analysis_type);
 
 		/*Now delete tria and triaelement: */
@@ -5295,5 +5295,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "PentaElementCreateGradjVectorsB"
-int PentaElementCreateGradjVectorsB( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type){
+int PentaElementCreateGradjVectorsB( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 
 	printf("Not supported yet!\n");
Index: issm/trunk/src/c/objects/cielo/TriaElement.c
===================================================================
--- issm/trunk/src/c/objects/cielo/TriaElement.c	(revision 464)
+++ issm/trunk/src/c/objects/cielo/TriaElement.c	(revision 465)
@@ -777,5 +777,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "TriaElementCreateKMatrix"
-int TriaElementCreateKMatrix( ElemMatrix* *pKe_gg, ElemMatrix** pKTe_gg, void* vpthis, ParameterInputs* inputs, int K_flag, int KT_flag, int analysis_type){
+int TriaElementCreateKMatrix( ElemMatrix* *pKe_gg, ElemMatrix** pKTe_gg, void* vpthis, ParameterInputs* inputs, int K_flag, int KT_flag, int analysis_type,int sub_analysis_type){
 
 
@@ -800,5 +800,5 @@
 #define __FUNCT__ "TriaElementCreatePVector"
 
-int TriaElementCreatePVector( ElemVector* *ppe_g, void* vpthis, ParameterInputs* inputs, int analysis_type){
+int TriaElementCreatePVector( ElemVector* *ppe_g, void* vpthis, ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 
 	int noerr=1;
@@ -2044,5 +2044,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "TriaElementCreateDuVector"
-int TriaElementCreateDuVector( ElemVector* *pdue_g, void* vpthis, double* velocity, double* obs_velocity, ParameterInputs* inputs, int analysis_type){
+int TriaElementCreateDuVector( ElemVector* *pdue_g, void* vpthis, double* velocity, double* obs_velocity, ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 					
 	int             i,j;
@@ -2263,13 +2263,13 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "TriaElementCreateGradVectors"
-int TriaElementCreateGradjVectors( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type,char* control_type){
+int TriaElementCreateGradjVectors( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type,int sub_analysis_type,char* control_type){
 
 	int noerr=1;
 	
 	if strcasecmp_eq(control_type,"drag"){
-		noerr=TriaElementCreateGradjVectorsDrag( pgradje_g, vpthis, velocity, adjoint, inputs,analysis_type);
+		noerr=TriaElementCreateGradjVectorsDrag( pgradje_g, vpthis, velocity, adjoint, inputs,analysis_type,sub_analysis_type);
 	}
 	else if strcasecmp_eq(control_type,"B"){
-		noerr=TriaElementCreateGradjVectorsB( pgradje_g, vpthis, velocity, adjoint, inputs,analysis_type);
+		noerr=TriaElementCreateGradjVectorsB( pgradje_g, vpthis, velocity, adjoint, inputs,analysis_type,sub_analysis_type);
 	}
 	else{
@@ -2285,5 +2285,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "TriaElementCreateGradVectorsDrag"
-int TriaElementCreateGradjVectorsDrag( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type){
+int TriaElementCreateGradjVectorsDrag( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 
 	int             i,j;
@@ -2566,5 +2566,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "TriaElementCreateGradjVectorsB"
-int TriaElementCreateGradjVectorsB( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type){
+int TriaElementCreateGradjVectorsB( ElemVector* *pgradje_g, void* vpthis, double* velocity, double* adjoint, ParameterInputs* inputs,int analysis_type,int sub_analysis_type){
 
 	int             i,j;
@@ -2770,5 +2770,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "TriaElementMisfit"
-int TriaElementMisfit( double* pJelem,void* vpthis, double* velocity, double* obs_velocity, ParameterInputs* inputs, int analysis_type){
+int TriaElementMisfit( double* pJelem,void* vpthis, double* velocity, double* obs_velocity, ParameterInputs* inputs, int analysis_type,int sub_analysis_type){
 
 	int             i,j;
Index: issm/trunk/src/c/parallel/CreateFemModel.cpp
===================================================================
--- issm/trunk/src/c/parallel/CreateFemModel.cpp	(revision 464)
+++ issm/trunk/src/c/parallel/CreateFemModel.cpp	(revision 465)
@@ -10,5 +10,5 @@
 #include "../issm.h"
 
-void CreateFemModel(FemModel* femmodel,ConstDataHandle MODEL,char* analysis_type){
+void CreateFemModel(FemModel* femmodel,ConstDataHandle MODEL,char* analysis_type,char* sub_analysis_type){
 
 	/*Model output: */
@@ -37,16 +37,8 @@
 	_printf_("   specifying analysis\n");
 	model->analysis_type=(char*)xmalloc((strlen(analysis_type)+1)*sizeof(char)); strcpy(model->analysis_type,analysis_type);
+	model->sub_analysis_type=(char*)xmalloc((strlen(sub_analysis_type)+1)*sizeof(char)); strcpy(model->sub_analysis_type,sub_analysis_type);
 
-	_printf_("   create elements, nodes and materials:\n");
-	CreateElementsNodesAndMaterials(&elements,&nodes,&materials,model,MODEL);
-
-	_printf_("   create constraints: \n");
-	CreateConstraints(&constraints,model,MODEL);
-	
-	_printf_("   create loads: \n");
-	CreateLoads(&loads,model,MODEL);
-
-	_printf_("   create parameters: \n");
-	CreateParameters(&parameters,model,MODEL);
+	_printf_("   create datasets:\n");
+	CreateDataSets(&elements,&nodes,&materials,&constraints,&loads,&parameters,model,MODEL);
 
 	_printf_("   create degrees of freedom: \n");
Index: issm/trunk/src/c/parallel/GradJCompute.cpp
===================================================================
--- issm/trunk/src/c/parallel/GradJCompute.cpp	(revision 464)
+++ issm/trunk/src/c/parallel/GradJCompute.cpp	(revision 465)
@@ -20,4 +20,5 @@
 	/*intermediary: */
 	int analysis_type;
+	int sub_analysis_type;
 	char* solverstring=NULL;
 	char* control_type=NULL;
@@ -42,13 +43,14 @@
 	/*some parameters:*/
 	femmodel->parameters->FindParam((void*)&analysis_type,"analysis_type");
+	femmodel->parameters->FindParam((void*)&sub_analysis_type,"sub_analysis_type");
 	femmodel->parameters->FindParam((void*)&solverstring,"solverstring");
 	femmodel->parameters->FindParam((void*)&control_type,"control_type");
 
 	_printf_("%s\n","      recover solution for this stiffness and right hand side:");
-	diagnostic_core_nonlinear(&u_g,&K_ff0,&K_fs0,femmodel,inputs,analysis_type);
+	diagnostic_core_nonlinear(&u_g,&K_ff0,&K_fs0,femmodel,inputs,analysis_type,sub_analysis_type);
 	VecToMPISerial(&u_g_double,u_g); VecFree(&u_g);
 
 	_printf_("%s\n","      buid Du, difference between observed velocity and model velocity:");
-	Dux( &du_g, femmodel->elements,femmodel->nodes,femmodel->loads,femmodel->materials,u_g_double,u_g_obs, inputs,analysis_type);
+	Dux( &du_g, femmodel->elements,femmodel->nodes,femmodel->loads,femmodel->materials,u_g_double,u_g_obs, inputs,analysis_type,sub_analysis_type);
 
 	_printf_("%s\n","      reduce adjoint load from g-set to f-set:");
@@ -68,5 +70,5 @@
 
 	Gradjx( &grad_g, femmodel->elements,femmodel->nodes, femmodel->loads, femmodel->materials, 
-		u_g_double,lambda_g_double, inputs,analysis_type,control_type);
+		u_g_double,lambda_g_double, inputs,analysis_type,sub_analysis_type,control_type);
 	
 	/*Free ressources:*/
Index: issm/trunk/src/c/parallel/control.cpp
===================================================================
--- issm/trunk/src/c/parallel/control.cpp	(revision 464)
+++ issm/trunk/src/c/parallel/control.cpp	(revision 465)
@@ -26,4 +26,5 @@
 	char* lockname=NULL;
 	int   analysis_type;
+	int   sub_analysis_type;
 
 	/*Intermediary: */
@@ -78,5 +79,5 @@
 	
 	_printf_("read and create finite element model:\n");
-	CreateFemModel(&femmodel,fid,"control");
+	CreateFemModel(&femmodel,fid,"control","");
 
 	/*Recover parameters used throughout the solution:*/
@@ -93,4 +94,5 @@
 	femmodel.parameters->FindParam((void*)&u_g_obs,"u_g_obs");
 	femmodel.parameters->FindParam((void*)&analysis_type,"analysis_type");
+	femmodel.parameters->FindParam((void*)&sub_analysis_type,"sub_analysis_type");
 	gsize=femmodel.nodes->NumberOfDofs();
 
@@ -156,5 +158,5 @@
 			inputs->Add(control_type,p_g,2,numberofnodes);
 			inputs->Add("fit",fit[n]);
-			diagnostic_core_nonlinear(&u_g,NULL,NULL,&femmodel,inputs,analysis_type);
+			diagnostic_core_nonlinear(&u_g,NULL,NULL,&femmodel,inputs,analysis_type,sub_analysis_type);
 			OutputControl(u_g,p_g,J,nsteps,femmodel.partition,outputfilename,femmodel.nodesets);
 			_printf_("%s\n","      done.");
@@ -175,5 +177,5 @@
 	UpdateFromInputsx(femmodel.elements,femmodel.nodes,femmodel.loads, femmodel.materials,inputs);
 	
-	diagnostic_core_nonlinear(&u_g,NULL,NULL,&femmodel,inputs,analysis_type);
+	diagnostic_core_nonlinear(&u_g,NULL,NULL,&femmodel,inputs,analysis_type,sub_analysis_type);
 	
 	_printf_("%s\n","      saving final results...");
Index: issm/trunk/src/c/parallel/diagnostic.cpp
===================================================================
--- issm/trunk/src/c/parallel/diagnostic.cpp	(revision 464)
+++ issm/trunk/src/c/parallel/diagnostic.cpp	(revision 465)
@@ -59,13 +59,13 @@
 	_printf_("read and create finite element model:\n");
 	_printf_("\n   reading diagnostic horiz model data:\n");
-	CreateFemModel(&femmodels[0],fid,"diagnostic_horiz");
+	CreateFemModel(&femmodels[0],fid,"diagnostic","horiz");
 	_printf_("\n   reading diagnostic vert model data:\n");
-	CreateFemModel(&femmodels[1],fid,"diagnostic_vert");
+	CreateFemModel(&femmodels[1],fid,"diagnostic","vert");
 	_printf_("\n   reading diagnostic stokes model data:\n");
-	CreateFemModel(&femmodels[2],fid,"diagnostic_stokes");
+	CreateFemModel(&femmodels[2],fid,"diagnostic","stokes");
 	_printf_("\n   reading diagnostic hutter model data:\n");
-	CreateFemModel(&femmodels[3],fid,"diagnostic_hutter");
+	CreateFemModel(&femmodels[3],fid,"diagnostic","hutter");
 	_printf_("\n   reading surface and bed slope computation model data:\n");
-	CreateFemModel(&femmodels[4],fid,"slope_compute");
+	CreateFemModel(&femmodels[4],fid,"slope_compute","");
 
 	_printf_("initialize inputs:\n");
